VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "MainForm"
   ClientHeight    =   3765
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6150
   LinkTopic       =   "MainForm"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3765
   ScaleWidth      =   6150
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton TestCommand 
      Caption         =   "Test"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4320
      TabIndex        =   0
      Top             =   2520
      Width           =   1215
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Type FTC_PAGE_WRITE_DATA
    NumPages As Integer
    NumBytesPerPage As Integer
End Type

Private Declare Function I2C_GetNumDevices Lib "ftci2c" (ByRef NumDevices As Long) As Long
Private Declare Function I2C_GetDeviceNameLocID Lib "ftci2c" (ByVal DeviceNameIndex As Long, ByVal DeviceName As String, ByVal BufferSize As Long, ByRef lpLocationID As Long) As Long
Private Declare Function I2C_OpenEx Lib "ftci2c" (ByVal DeviceName As String, ByVal LocationID As Long, ByRef ftHandle As Long) As Long
Private Declare Function I2C_Open Lib "ftci2c" (ByRef ftHandle As Long) As Long
Private Declare Function I2C_Close Lib "ftci2c" (ByVal ftHandle As Long) As Long
Private Declare Function I2C_InitDevice Lib "ftci2c" (ByVal ftHandle As Long, ByVal ClockDivisor As Long) As Long
Private Declare Function I2C_GetClock Lib "ftci2c" (ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function I2C_SetClock Lib "ftci2c" (ByVal ftHandle As Long, ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function I2C_SetLoopback Lib "ftci2c" (ByVal ftHandle As Long, ByVal bLoopbackState As Boolean) As Long
Private Declare Function I2C_SetMode Lib "ftci2c" (ByVal ftHandle As Long, ByVal CommsMode As Long) As Long
Private Declare Function I2C_Write Lib "ftci2c" (ByVal ftHandle As Long, WriteControlBuffer As Any, ByVal NumControlBytesToWrite As Long, ByVal bControlAcknowledge As Boolean, ByVal NumControlAckTimeoutmSecs As Long, ByVal bStopCondition As Boolean, ByVal DataWriteTypes As Long, WriteDataBuffer As Any, ByVal NumDataBytesToWrite As Long, ByVal bDataAcknowledge As Boolean, ByVal NumDataAckTimeoutmSecs As Long, ByRef pPageWriteData As FTC_PAGE_WRITE_DATA) As Long
Private Declare Function I2C_Read Lib "ftci2c" (ByVal ftHandle As Long, WriteControlBuffer As Any, ByVal NumControlBytesToWrite As Long, ByVal bControlAcknowledge As Boolean, ByVal NumControlAckTimeoutmSecs As Long, ByVal DataReadType As Long, ReadDataBuffer As Any, ByVal NumDataBytesToRead As Long) As Long
Private Declare Function I2C_GetDllVersion Lib "ftci2c" (ByVal DllVersion As String, ByVal BufferSize As Long) As Long
Private Declare Function I2C_GetErrorCodeString Lib "ftci2c" (ByVal Language As String, ByVal StatusCode As Long, ByVal ErrorMessage As String, ByVal BufferSize As Long) As Long

Private Declare Function Sleep Lib "Kernel32" (ByVal Milliseconds As Integer) As Long

Private Const FTC_SUCCESS = 0

Private Const NO_WRITE_TYPE = 0
Private Const BYTE_WRITE_TYPE = 1
Private Const PAGE_WRITE_TYPE = 2

Private Const BYTE_READ_TYPE = 1
Private Const PAGE_READ_TYPE = 2

Private Const STANDARD_MODE = 1
Private Const FAST_MODE = 2

Private Const WRITE_CONTROL_BUFFER_SIZE = 256
Private Const WRITE_DATA_BUFFER_SIZE = 65536
Private Const READ_DATA_BUFFER_SIZE = 65536

Private Const MAX_NUM_DEVICE_NAME_CHARS = 100

Private Const MAX_NUM_DLL_VERSION_CHARS = 10

Private Const MAX_NUM_ERROR_MESSAGE_CHARS = 100

Private Const MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES = 512

Private Const NUM_M24C64_PAGES = 1
Private Const NUM_M24C64_BYTES_PER_PAGE = 32

Private Const MAX_FREQ_M24C64_CLOCK_DIVISOR = 15   ' equivalent to 400KHz
'Private Const MAX_FREQ_M24C64_CLOCK_DIVISOR = 60   ' equivalent to 100KHz
    
Private Const App_Title = "FT2232C I2C Device Visual Basic V6.0 Test Application"

    
Private ftHandle As Long
Private Sub Form_Load()

    MainForm.Caption = App_Title
    
    ftHandle = 0
End Sub
Private Sub Form_Unload(Cancel As Integer)
        Dim ftStatus As Long
        
        ftStatus = DS_SUCCESS

        If (ftHandle <> 0) Then
            ftStatus = I2C_Close(ftHandle)
        End If
End Sub
Private Function ConvertDLLStringToVBString(ByRef DLLString As String) As String
    Dim VBString As String
    Dim DllCharCntr As Long
    Dim VBCharCntr As Long
    Dim DLLStrCharArray() As Byte
    Dim VBStrCharArray() As Byte
        
    DllCharCntr = 0

    DLLStrCharArray = StrConv(DLLString, vbFromUnicode)   ' Convert string.

    While (DLLStrCharArray(DllCharCntr) <> 0)
        DllCharCntr = DllCharCntr + 1
    Wend
        
    ReDim VBStrCharArray(0 To (DllCharCntr - 1)) As Byte
    For VBCharCntr = 0 To (DllCharCntr - 1)
        VBStrCharArray(VBCharCntr) = DLLStrCharArray(VBCharCntr)
    Next

    ConvertDLLStringToVBString = StrConv(VBStrCharArray, vbUnicode)
End Function

Private Sub TestCommand_Click()
    Dim ftStatus As Integer
    Dim NumDevices As Long
    Dim DeviceName As String
    Dim DN As String
    Dim LocationID As Long
    Dim ClockFrequencyHz As Long
    Dim bLoopbackState As Boolean
    Dim DataWriteType As Integer
    Dim WriteDataByteAddress As Integer
    Dim WriteControlBuffer((WRITE_CONTROL_BUFFER_SIZE - 1)) As Byte
    Dim DataByte As Byte
    Dim WriteDataBuffer((WRITE_DATA_BUFFER_SIZE - 1)) As Byte
    Dim NumDataBytesToWrite As Integer
    Dim WriteDataBufferIndex As Integer
    Dim PageWriteData As FTC_PAGE_WRITE_DATA
    Dim ReadDataBuffer((WRITE_DATA_BUFFER_SIZE - 1)) As Byte
    Dim ReadData((WRITE_DATA_BUFFER_SIZE - 1)) As Byte
    Dim ReadDataIndex As Integer
    Dim ReadDataByteAddress As Integer
    Dim DataReadType As Integer
    Dim NumDataBytesToRead As Long
    Dim MsgBoxKeyPressed As Integer
    Dim DataByteWritten As Byte
    Dim CharCntr As Integer
    Dim iLoopCntr As Integer
    Dim Msg, Style, Title, Response As String
    Dim ErrorMessage As String
    'Dim DllVersion As String
    
    ftStatus = FTC_SUCCESS
    NumDevices = 0
    DeviceName = String$(MAX_NUM_DEVICE_NAME_CHARS, Chr(0))
    LocationID = 0
    ClockFrequencyHz = 0
    bLoopbackState = False
    DataByte = 0
    NumDataBytesToWrite = 0
    WriteDataBufferIndex = 0
    ReadDataIndex = 0
    ReadDataByteAddress = 0
    DataReadType = 0
    NumDataBytesToRead = 0
    MsgBoxKeyPressed = 0
    DataByteWritten = 0
    CharCntr = 0
    iLoopCntr = 0
    
    ErrorMessage = String$(MAX_NUM_ERROR_MESSAGE_CHARS, ChrW(0))
    
    'DllVersion = String$(MAX_NUM_DLL_VERSION_CHARS, Chr(0))
    'ftStatus = I2C_GetDllVersion(DllVersion, MAX_NUM_DLL_VERSION_CHARS)
    'MsgBox (DllVersion)
    
    ftStatus = I2C_GetNumDevices(NumDevices)
    
    If ((ftStatus = FTC_SUCCESS) And (NumDevices > 0)) Then
        If (NumDevices = 1) Then
            ftStatus = I2C_GetDeviceNameLocID(0, DeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID)

            If (ftStatus = FTC_SUCCESS) Then
                DN = ConvertDLLStringToVBString(DeviceName)
                ftStatus = I2C_OpenEx(DN, LocationID, ftHandle)
            End If

            'ftStatus = I2C_Open(ftHandle)
        Else
            If (NumDevices = 2) Then
                ftStatus = I2C_GetDeviceNameLocID(1, DeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID)

                If (ftStatus = FTC_SUCCESS) Then
                    DN = ConvertDLLStringToVBString(DeviceName)
                    ftStatus = I2C_OpenEx(DN, LocationID, ftHandle)
                End If

                'ftStatus = I2C_Open(ftHandle)
            End If
        End If

        If ((ftHandle <> 0) And (ftStatus = FTC_SUCCESS)) Then
            ftStatus = I2C_InitDevice(ftHandle, MAX_FREQ_M24C64_CLOCK_DIVISOR)

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = I2C_GetClock(60, ClockFrequencyHz)
            End If

            'If (ftStatus = FTC_SUCCESS) Then
            'ftStatus = I2C_SetLoopback(ftHandle, False)
            'End If
            
            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = I2C_SetMode(ftHandle, FAST_MODE)
            End If

            If (ftStatus = FTC_SUCCESS) Then
                WriteControlBuffer(0) = &HAE '1 0 1 0 A2 A1 A0 0 - device address 7

                WriteDataBuffer(0) = &HFF  ' Erase address locations

                WriteDataByteAddress = 0

                Do
                    ' shift down by 8 bits
                    WriteControlBuffer(1) = ((WriteDataByteAddress > 8) And &HFF)
                    WriteControlBuffer(2) = (WriteDataByteAddress And &HFF)

                    ftStatus = I2C_Write(ftHandle, WriteControlBuffer(0), 3, True, 20, True, BYTE_WRITE_TYPE, WriteDataBuffer(0), 1, True, 20, PageWriteData)

                    WriteDataByteAddress = WriteDataByteAddress + 1
                Loop While ((WriteDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                Sleep (200)
           End If

           If (ftStatus = FTC_SUCCESS) Then
                WriteControlBuffer(0) = &HAE '1 0 1 0 A2 A1 A0 0 - device address 7

                WriteDataByteAddress = 0

                DataWriteType = BYTE_WRITE_TYPE 'PAGE_WRITE_TYPE ';

                DataByte = &H77

                If (DataWriteType = BYTE_WRITE_TYPE) Then
                    WriteDataBuffer(0) = DataByte

                    NumDataBytesToWrite = 1
                Else
                    WriteDataBuffer(0) = DataByte

                    PageWriteData.NumPages = NUM_M24C64_PAGES
                    PageWriteData.NumBytesPerPage = NUM_M24C64_BYTES_PER_PAGE

                    NumDataBytesToWrite = (NUM_M24C64_PAGES * NUM_M24C64_BYTES_PER_PAGE)

                    For WriteDataBufferIndex = 0 To (NumDataBytesToWrite - 1)
                        WriteDataBuffer(WriteDataBufferIndex) = DataByte
                    Next
                End If

                Do
                    ' performs an arithmetic right shift down by 8 bits
                    WriteControlBuffer(1) = ((WriteDataByteAddress > 8) And &HFF)
                    WriteControlBuffer(2) = (WriteDataByteAddress And &HFF)

                    ftStatus = I2C_Write(ftHandle, WriteControlBuffer(0), 3, True, 20, True, DataWriteType, WriteDataBuffer(0), NumDataBytesToWrite, True, 20, PageWriteData)

                    If (DataWriteType = BYTE_WRITE_TYPE) Then
                        WriteDataByteAddress = WriteDataByteAddress + 1
                    Else
                        WriteDataByteAddress = WriteDataByteAddress + (NUM_M24C64_PAGES * NUM_M24C64_BYTES_PER_PAGE)
                    End If
                Loop While ((WriteDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                If (ftStatus = FTC_SUCCESS) Then
                     Do
                        Sleep (200)

                        WriteControlBuffer(0) = &HAF '1 0 1 0 A2 A1 A0 1 - device address 7

                        For ReadDataIndex = 0 To (MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES - 1)
                            ReadData(ReadDataIndex) = 0
                        Next

                        ReadDataByteAddress = 0
                        
                        DataReadType = BYTE_READ_TYPE 'BLOCK_READ_TYPE '

                        If (DataReadType = BYTE_READ_TYPE) Then
                            NumDataBytesToRead = 1
                        Else
                            NumDataBytesToRead = MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES
                        End If

                        Do
                            ' shift down by 8 bits
                            WriteControlBuffer(1) = ((ReadDataByteAddress > 8) And &HFF)
                            WriteControlBuffer(2) = (ReadDataByteAddress And &HFF)

                            ftStatus = I2C_Read(ftHandle, WriteControlBuffer(0), 3, True, 20, DataReadType, ReadDataBuffer(0), NumDataBytesToRead)

                            If (ftStatus = FTC_SUCCESS) Then
                                If (DataReadType = BYTE_READ_TYPE) Then
                                    ReadData(ReadDataByteAddress) = ReadDataBuffer(0)
                                Else
                                    For ReadDataIndex = 0 To (MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES - 1)
                                        ReadData(ReadDataIndex) = ReadDataBuffer(ReadDataIndex)
                                    Next
                                End If

                                If (DataReadType = BYTE_READ_TYPE) Then
                                    ReadDataByteAddress = ReadDataByteAddress + 1
                                Else
                                    ReadDataByteAddress = ReadDataByteAddress + MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES
                                End If
                            End If
                        Loop While ((ReadDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                        If (ftStatus = FTC_SUCCESS) Then
                            ReadDataIndex = 0

                            Response = vbOK
                            Style = vbOKCancel + vbCritical   ' Define buttons.
                            Title = "I2C Read Error Message"   ' Define title.

                            Do
                                If (DataByte <> 0) Then
                                    DataByteWritten = DataByte
                                Else
                                    DataByteWritten = (ReadDataIndex And &HFF)
                                End If

                                If (((ReadData(ReadDataIndex) <> DataByteWritten) And (DataByte <> 0)) Or ((ReadData(ReadDataIndex) <> DataByteWritten) And (DataByte = 0))) Then
                                    For CharCntr = 0 To (100 - 1)
                                        WriteDataBuffer(CharCntr) = 0
                                    Next

                                    Msg = "I2C M24C64 Read/Write mismatch, Address = " + Format(ReadDataIndex) + ", Write Value = " + Format(DataByteWritten) + ", Read Value = " + Format(ReadData(ReadDataIndex))

                                    Response = MsgBox(Msg, Style, Title)
                                End If

                                ReadDataIndex = ReadDataIndex + 1
                            Loop While ((ReadDataIndex < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (Response = vbOK))
                        End If
                        
                        iLoopCntr = iLoopCntr + 1
                    Loop While ((iLoopCntr < 20) And (ftStatus = FTC_SUCCESS))

                    I2C_Close (ftHandle)
                    ftHandle = 0
                End If
            End If
        End If
    End If

    If (ftStatus <> FTC_SUCCESS) Then
        ftStatus = I2C_GetErrorCodeString("EN", ftStatus, ErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)

        MsgBox (ErrorMessage)
    End If
End Sub

